HDU 4027(线段树区间更新+区间求和)-Can you answer these queries?

题目:

A lot of battleships of evil are arranged in a line before the battle. Our commander decides to use our secret weapon to eliminate the battleships. Each of the battleships can be marked a value of endurance. For every attack of our secret weapon, it could decrease the endurance of a consecutive part of battleships by make their endurance to the square root of it original value of endurance. During the series of attack of our secret weapon, the commander wants to evaluate the effect of the weapon, so he asks you for help.
You are asked to answer the queries that the sum of the endurance of a consecutive part of the battleship line.

Notice that the square root operation should be rounded down to integer.

Input

The input contains several test cases, terminated by EOF.
  For each test case, the first line contains a single integer N, denoting there are N battleships of evil in a line. (1 <= N <= 100000)
  The second line contains N integers Ei, indicating the endurance value of each battleship from the beginning of the line to the end. You can assume that the sum of all endurance value is less than 2 63.
  The next line contains an integer M, denoting the number of actions and queries. (1 <= M <= 100000)
  For the following M lines, each line contains three integers T, X and Y. The T=0 denoting the action of the secret weapon, which will decrease the endurance value of the battleships between the X-th and Y-th battleship, inclusive. The T=1 denoting the query of the commander which ask for the sum of the endurance value of the battleship between X-th and Y-th, inclusive.

Output

For each test case, print the case number at the first line. Then print one line for each query. And remember follow a blank line after each test case.

Sample Input

10
1 2 3 4 5 6 7 8 9 10
5
0 1 10
1 1 10
1 1 5
0 5 8
1 4 8

题意:
给出一排敌军的血量,每次攻击都能将范围内的敌军血量变为原来血量的算术平方根(下取整),并询问范围内敌军的血量和。
分析:
显然的线段树,但是似乎不太好设计lazy标记啊,我们想一想算术平方根,sqrt(1)=1,且64位整数范围内最多6次就变到1了,那么只要区间内的数都为1,我就不用更新这个区间了,所以每次更新都更新到叶子结点,维护区间和就行了。数据里没有0,不过X>Y这种trick有意思吗?

代码:

#include<iostream>//因为int型的树开最多6次的开方就为1,而且没有0,所以就借助sqrt(1)=1;无需更新了。 
#include<cstdio>//来降低时间复杂度 
#include<cstring>
#include<algorithm>
#include<cmath>
#include<map>
#include<set>
#include<stack>
#include<queue>
#include<vector>
#define ll long long
using namespace std;
int n,m;
const int INF=1e5+5;
ll a[INF];
struct node{
    int right;
    int left;
    ll sum;
    int flag;//为0,代表区间内只有1 
}f[4*INF];
void build(int ans,int l,int r)
{
    f[ans].left =l;
    f[ans].right =r;
    if(l==r)
    {
        f[ans].sum =a[l];f[ans].flag =1;
		if(f[ans].sum <=1)f[ans].flag=0;
	return;
    }
    int mid=(l+r)/2;
    build(ans<<1,l,mid);
    build(ans<<1|1,mid+1,r);
    f[ans].sum =f[ans<<1].sum+f[ans<<1|1].sum ; 
    f[ans].flag =(f[ans<<1].flag )|(f[ans<<1|1].flag );
}
void update(int ans,int l,int r)
{
    if(f[ans].left ==l&&f[ans].right ==r&&l==r)
    {
        f[ans].sum =(ll)sqrt((double)f[ans].sum );
        f[ans].flag =1;if(f[ans].sum<=1)f[ans].flag=0;
        return;
    }
    if(f[ans].flag ==0)return;
    int mid=(f[ans].left +f[ans].right )/2;
    if(r<=mid)update(ans<<1,l,r);
    else if(l>mid)update(ans<<1|1,l,r);
    else {
        update(ans<<1,l,mid);update(ans<<1|1,mid+1,r);
    }
    f[ans].sum =f[ans<<1].sum+f[ans<<1|1].sum ; 
    f[ans].flag =(f[ans<<1].flag )|(f[ans<<1|1].flag );
}
ll getsum(int ans,int l,int r)
{
    if(f[ans].left ==l&&f[ans].right ==r)
    {
        return f[ans].sum ;
    }
    int mid=(f[ans].left +f[ans].right )/2;
    if(r<=mid){
        return getsum(ans<<1,l,r);
    }
    else if(l>mid){
        return getsum(ans<<1|1,l,r);
    }
    else {
        return getsum(ans<<1,l,mid)+getsum(ans<<1|1,mid+1,r);
    }
}
int main()
{
    int t=0;
    while(scanf("%d",&n)!=EOF)
    {
        t++;
        int i,j,k,val;
        for(i=1;i<=n;i++)
        {
            scanf("%lld",&a[i]);
        }
        build(1,1,n);
        scanf("%d",&m);
        printf("Case #%d:\n",t);
        for(i=1;i<=m;i++)
        {
            scanf("%d%d%d",&val,&j,&k);
            if(j>k)swap(j,k);
            if(val==0)
            {
                update(1,j,k);
            }
            else {
                printf("%lld\n",getsum(1,j,k));
            }
        }
        printf("\n");
    }
    return 0;    
} 

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值